package org.omg.IOP;

import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.Object;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class CodecFactoryHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public CodecFactoryHelper() {
    }
    
    public static void insert(Any any, CodecFactory codecFactory) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, codecFactory);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static CodecFactory extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (CodecFactoryHelper.__typeCode == null) {
            CodecFactoryHelper.__typeCode = ORB.init().create_interface_tc(id(), "CodecFactory");
        }
        return CodecFactoryHelper.__typeCode;
    }
    
    public static String id() {
        return CodecFactoryHelper._id;
    }
    
    public static CodecFactory read(InputStream inputStream) {
        throw new MARSHAL();
    }
    
    public static void write(OutputStream outputStream, CodecFactory codecFactory) {
        throw new MARSHAL();
    }
    
    public static CodecFactory narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof CodecFactory)) {
            return (CodecFactory)object;
        }
        throw new BAD_PARAM();
    }
    
    public static CodecFactory unchecked_narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof CodecFactory)) {
            return (CodecFactory)object;
        }
        throw new BAD_PARAM();
    }
    
    static {
        CodecFactoryHelper._id = "IDL:omg.org/IOP/CodecFactory:1.0";
        CodecFactoryHelper.__typeCode = null;
    }
}
